#!/usr/bin/perl -w
#
#suche push-fields mit vorgetuschten Qualifikationen
#suche nach Konstante = Konstante
#
#
# angepasstes PERL-Skript von
# MTI - Management of Technology and Information
# Dr. Martin Rosenbauer
# Letzte Aenderung 20051108 (Version 0.2)
# 
#Voraussetzung: Installation von Standard-Perl jeder Version.
# unter Windows: Download von www.activestate.com
#
#Aufruf unter Unix, z.B.:
# perl ./suchePushField.pl deffile.def
# oder
# perl ./suchePushField.pl
#
#Unter Windows: einfach Doppelklick auf das Programm....
#
# Ausgabe: erfolgt in Datei
# "<Eingabedateiname_ohne_Extension>_result.txt"
##



use strict;

my $debug = 0;
my $oName;
my $oTyp;
my $oExpr;
my $pushExpr = "      push-field  : ";
my $nameExpr = "   name           : ";
my $typeExpr = "begin ";
my $typIndex1 = 9;
my $typConstantToken = "2";
my $typIndexOffsetTo2 = 3;
my $pushFieldTypeIndexOffset = 3;
my $pushFieldTokenCreate = "4";
my $line;
my @allLines;
my @linePart;
my %escalat;
my %actLink;
my %filter;
my $outFileName;


my $fileName="";

if (defined ($ARGV[0])) {
   $fileName = $ARGV[0];
} else {
   print "\nName def Datei : ";
   $fileName=<STDIN>;
   print "\n\n";
};
chomp $fileName;
$outFileName=$fileName;
$outFileName=~s/\..*$//goi;
$outFileName=$outFileName . "_result.txt";


open (DEFFILE, "<$fileName");
@allLines = <DEFFILE>;
close (DEFFILE);

LINELOOP: foreach $line (@allLines) {
   chomp $line;
   print "$line\n" if ($debug > 3);
   if ($line =~ /^$typeExpr(.*)$/io){
      $oTyp = $1;
   } elsif ($line =~ /^$nameExpr(.*)$/io) {
      $oName = $1;
   } elsif ($line =~ /^$pushExpr(.*)$/io) {
      $oExpr = $1;
      @linePart = (split /\\/, $oExpr);

      # Wenn der Typ-Wert an Position 9 nicht definiert ist,
      #  dann handelt es sich 
      #  nicht um eine typische Push-Field-Aktion mit 1=1 o..
      #  d.h., die Zeile kann ignoriert werden
      # (wir verzichten hier daraum, Fortsetzungszeilen
      #  zusammen zu fgen)
      if ((!(defined $linePart[$typIndex1]))
          or ($linePart[$typIndex1] eq "")){
                  print "$line\n" if ($debug > 2);
		  next LINELOOP;
      };

      if ($linePart[$typIndex1] eq "$typConstantToken"){
         if ($linePart[($typIndex1 + $typIndexOffsetTo2)] eq
					"$typConstantToken"){
	    if ($linePart[($typIndex1 + $typIndexOffsetTo2
		    	   + $pushFieldTypeIndexOffset)] eq
					"$pushFieldTokenCreate"){
               if ($oTyp eq "" or (!(defined $oTyp))){
                  print "$line\n" if ($debug > 1);
               };
               if ($oTyp =~ /filter/io){
	          $filter{"$oName"} = "$linePart[11] op $linePart[14]";
	       } elsif ($oTyp =~ /active link/io){
	          $actLink{"$oName"} = "$linePart[11] op $linePart[14]";
	       } elsif ($oTyp =~ /escalat/io){
	          $escalat{"$oName"} = "$linePart[11] op $linePart[14]";
	       };
	    };	    
         };
      };
   };
};

open (OUTFILE, ">$outFileName");

foreach $oName (sort keys %actLink) {
   print OUTFILE "act. Link $oName ... mit condition $actLink{$oName}\n";
};
print OUTFILE "\n";
foreach $oName (sort keys %filter) {
   print OUTFILE "filter $oName ... mit condition $filter{$oName}\n";
};
print OUTFILE "\n";
foreach $oName (sort keys %escalat) {
   print OUTFILE "escalation $oName ... mit condition $escalat{$oName}\n";
};
print OUTFILE "\n";

close (OUTFILE);
